module DynProg where

import Cost
import List
import Util

dynProg :: (a -> a -> a -> a) -> a -> [a] -> [[a]]
dynProg f z l = xs
  where xs = l:[zipWith' (innerProd z)
                         (transpose (take n xs))
                         (transpose (zipWith drop [1..n] (reverse (take n xs))))
                | n <- [1..]]
	{- innerProd :: [a] -> [a] -> a -}
	innerProd o (n1:n1s) (n2:n2s) = n `seq` innerProd n n1s n2s
	   where n = f o n1 n2
        innerProd o _ _ = o
